import { Observable } from "rxjs/Observable";
import { IItemClientOptions } from "../interfaces";
import { HtBaseApi } from "../api/base";
import { HtBaseClient } from "./base-client";
export declare abstract class ItemClient<T> extends HtBaseClient<T> {
    options: IItemClientOptions<T>;
    api: HtBaseApi;
    defaultQuery: object;
    name: string;
    toUpdate: boolean;
    constructor(options: IItemClientOptions<T>);
    initEffects(): void;
    getApiQuery$(): Observable<{
        id: {};
        query: object;
    }>;
    getData$(id: any, query: any): Observable<T>;
    readonly abstract id$: any;
    readonly abstract loading$: any;
    isNotFound(): void;
    onDataUpdate(data: T): void;
}
