import { Action } from "../store/models";
import { IDateRange } from "../interfaces";
export declare const SET_DATE_RANGE = "[QUERY] set date range";
export declare const SET_USER_QUERY = "[QUERY] set user query";
export declare const SET_USER_QUERY_RESET_PAGE = "[QUERY] set user query reset page";
export declare const CLEAR_USER_QUERY_KEY = "[QUERY] clear user query key";
export declare const SET_PLACELINE_ID = "[USERS] set placeline id";
export declare const SET_USER_ID = "[USERS] set user id";
export declare const TOGGLE_USER_ID = "[USERS] toggle user id";
export declare const TOGGLE_PLACELINE_ID = "[USERS] toggle placeline id";
export declare class SetDateRange implements Action {
    payload: IDateRange;
    readonly type: string;
    constructor(payload: IDateRange);
}
export declare class SetUserQuery implements Action {
    payload: object | null;
    readonly type: string;
    constructor(payload: object | null);
}
export declare class SetUserQueryResetPage implements Action {
    payload: object | null;
    readonly type: string;
    constructor(payload: object | null);
}
export declare class ClearUserQueryKey implements Action {
    payload: string;
    readonly type: string;
    constructor(payload: string);
}
export declare class SetPlacelineId implements Action {
    payload: string | null;
    readonly type: string;
    constructor(payload: string | null);
}
export declare class SetUserId implements Action {
    payload: string | null;
    readonly type: string;
    constructor(payload: string | null);
}
export declare class ToggleUserId implements Action {
    payload: string;
    readonly type: string;
    constructor(payload: string);
}
export declare class TogglePlacelineId implements Action {
    payload: string;
    readonly type: string;
    constructor(payload: string);
}
export declare type All = SetDateRange | SetUserQuery | SetUserQueryResetPage | ClearUserQueryKey | SetPlacelineId | SetUserId | ToggleUserId | TogglePlacelineId;
