import { Action } from "../store/models";
import { IUserData } from "ht-models";
import { IUserAnalytics, IUser, Page, IUserListSummary } from "ht-models";
import { AllData, ApiType } from "../interfaces";
export declare const SET_USER_DATA = "[USERS] set user data";
export declare const SET_USERS_ANALYTICS_PAGE = "[USERS] set user analytics page";
export declare const SET_USERS_INDEX_PAGE = "[USERS] set user index page";
export declare const SET_USERS_ANALYTICS_ALL = "[USERS] set users analytics all";
export declare const SET_USERS_INDEX_ALL = "[USERS] set users index all";
export declare const SET_USERS_SUMMARY = "[USERS] set users summary";
export declare const SET_USERS_LIST_API_TYPE = "[USERS] set users list api type";
export declare const SET_USERS_LIST_DATA_MAP = "[USERS] set users list data map";
export declare const SET_USERS_MARKERS_DATA_MAP = "[USERS] set users markers data map";
export declare const INIT_USERS_LIST = "[USERS] init users list";
export declare const INIT_USERS_MARKERS = "[USERS] init users markers";
export declare const INIT_USERS = "[USERS] init users";
export declare const PAUSE_USERS = "[USERS] pause users";
export declare const SET_LIST_ACTIVE = "[USERS] set list active";
export declare const SET_MARKERS_ACTIVE = "[USERS] set markerS active";
export declare const SET_SUMMARY_ACTIVE = "[USERS] set summary active";
export declare class SetUserData implements Action {
    payload: IUserData | null;
    readonly type: string;
    constructor(payload: IUserData | null);
}
export declare class SetUsersAnalyticsPage implements Action {
    payload: Page<IUserAnalytics>;
    readonly type: string;
    constructor(payload: Page<IUserAnalytics>);
}
export declare class SetUsersIndexPage implements Action {
    payload: Page<IUser>;
    readonly type: string;
    constructor(payload: Page<IUser>);
}
export declare class SetUsersAnalyticsAll implements Action {
    payload: AllData<IUserAnalytics>;
    readonly type: string;
    constructor(payload: AllData<IUserAnalytics>);
}
export declare class SetUsersIndexAll implements Action {
    payload: AllData<IUser>;
    readonly type: string;
    constructor(payload: AllData<IUser>);
}
export declare class SetUsersSummary implements Action {
    payload: IUserListSummary;
    readonly type: string;
    constructor(payload: IUserListSummary);
}
export declare class SetUsersListApiType implements Action {
    payload: ApiType;
    readonly type: string;
    constructor(payload: ApiType);
}
export declare class SetUsersListDataMap implements Action {
    payload: (user) => any;
    readonly type: string;
    constructor(payload: (user) => any);
}
export declare class SetUsersMarkersDataMap implements Action {
    payload: (data) => any;
    readonly type: string;
    constructor(payload: (data) => any);
}
export declare class InitUsersList implements Action {
    payload: boolean;
    readonly type: string;
    constructor(payload?: boolean);
}
export declare class InitUsersMarkers implements Action {
    payload: boolean;
    readonly type: string;
    constructor(payload?: boolean);
}
export declare class InitUsers implements Action {
    readonly type: string;
    constructor();
}
export declare class PauseUsers implements Action {
    readonly type: string;
    constructor();
}
export declare class SetListActive implements Action {
    payload: boolean;
    readonly type: string;
    constructor(payload?: boolean);
}
export declare class SetMarkersActive implements Action {
    payload: boolean;
    readonly type: string;
    constructor(payload?: boolean);
}
export declare class SetSummaryActive implements Action {
    payload: boolean;
    readonly type: string;
    constructor(payload?: boolean);
}
export declare type All = SetUserData | SetUsersAnalyticsPage | SetUsersIndexPage | SetUsersAnalyticsAll | SetUsersIndexAll | SetUsersSummary | SetUsersListApiType | SetUsersListDataMap | SetUsersMarkersDataMap | InitUsersList | InitUsersMarkers | InitUsers | PauseUsers | SetListActive | SetMarkersActive | SetSummaryActive;
