import { BehaviorSubject } from "rxjs/BehaviorSubject";
import { Observable } from "rxjs/Observable";
import { Partial, Page, IAction } from "ht-models";
import { IIndexQuery, IListConfig } from "../../interfaces";
import { HtActionsApi } from "../../api/actions";
export declare class HtActionsListClient {
    defaultConfigQuery: Partial<IIndexQuery>;
    private config;
    update$: any;
    pageSet$: any;
    api: HtActionsApi;
    pageDataBeh$: BehaviorSubject<Page<IAction> | null>;
    listQueryBeh$: BehaviorSubject<object>;
    pageQueryBeh$: BehaviorSubject<object>;
    dateRangeQueryBeh$: BehaviorSubject<object>;
    query: Observable<object>;
    constructor(request: any, defaultConfigQuery?: Partial<IIndexQuery>, config?: IListConfig);
    initListeners(): void;
    init({listQuery, pageQuery, dateRangeQuery}: {
        listQuery: any;
        pageQuery: any;
        dateRangeQuery: any;
    }, config?: any): void;
    private setDefaultQuery(defaultConfigQuery);
    readonly pageData$: Observable<Page<IAction>>;
    readonly listQuery$: Observable<object>;
    readonly pageQuery$: Observable<object>;
    readonly dateRangeQuery$: Observable<object>;
    updateListQuery(listQuery?: any): void;
    updatePageQuery(pageQuery?: any): void;
    updateDateRangeQuery(dateRangeQuery?: any): void;
    setListQuery(listQuery?: any): void;
    setPageQuery(pageQuery?: any): void;
    setDateRangeQuery(dateRangeQuery?: any): void;
    turnPage(next?: boolean): void;
    setPage(number: any): void;
    private isValidPage(pageSize, count, page?);
    update(query: any, isLive?: boolean): Observable<any>;
    private updatedPageData(pageData, updatedPageData);
    private getIds(pageData);
    clear(): void;
}
