import { Store } from "../../store/store";
import * as fromRoot from "../../reducers";
import { Observable } from "rxjs/Observable";
import { ApiType } from "../../interfaces";
import { IUserAnalyticsPage, IUserPage } from "ht-models";
import { HtListClient } from "../../base/list-client";
import { Subscription } from "rxjs/Subscription";
export declare class UsersList {
    store: Store<fromRoot.State>;
    private usersIndexClient;
    private usersAnalyticsClient;
    constructor(store: Store<fromRoot.State>, usersIndexClient: HtListClient<IUserPage | any>, usersAnalyticsClient: HtListClient<IUserAnalyticsPage | any>);
    readonly isActive$: Observable<boolean>;
    readonly id$: Store<string>;
    readonly data$: Observable<{}>;
    readonly loading$: Observable<{}>;
    readonly query$: Observable<object>;
    readonly dataArray$: Observable<any>;
    readonly apiType: Store<ApiType>;
    getApiQuery$(): Observable<any>;
    updateSelectedId(id: string | null): void;
    updateQuery(query: object): void;
    updateQueryResetPage(query: object): void;
    clearQueryKey(key: string): void;
    setId(userId: string | null): void;
    toggleId(userId: string): void;
    setApiType(apiType: ApiType): void;
    setActive(isActive: any): void;
    setLive(isLive: boolean): Subscription;
    protected getForApiType(apiType: ApiType): HtListClient<any>;
    protected getClient(): Observable<HtListClient<any>>;
}
