import * as UserDispatch from "../dispatchers/user-dispatcher";
import { IUserData, Page, IUser, IUserAnalytics, IUserListSummary } from "ht-models";
import { AllData, ApiType } from "../interfaces";
import { MemoizedSelector } from "../store/selector";
export interface State {
    userData?: IUserData;
    usersAnalyticsPage?: Page<IUserAnalytics>;
    usersIndexPage?: Page<IUser>;
    listApiType: ApiType;
    usersAnalyticsAll?: AllData<IUserAnalytics>;
    usersIndexAll?: AllData<IUser>;
    usersListDataMap?: (data) => any;
    usersMarkersDataMap?: (data) => any;
    usersSummary?: IUserListSummary | null;
    usersListActive: boolean;
    usersMarkersActive: boolean;
    usersSummaryActive: boolean;
}
export declare function usersReducer(state: State, action: UserDispatch.All): State;
export declare const getUserData: (state: State) => IUserData;
export declare const getAnalyticsAll: (state: State) => AllData<IUserAnalytics>;
export declare const getIndexAll: (state: State) => AllData<IUser>;
export declare const getMarkerDataMap: (state: State) => (data: any) => any;
export declare const getIndexPage: (state: State) => Page<IUser>;
export declare const getAnalyticsPage: (state: State) => Page<IUserAnalytics>;
export declare const getListApiType: (state: State) => ApiType;
export declare const getListActive: (state: State) => boolean;
export declare const getMarkersActive: (state: State) => boolean;
export declare const getSummary: (state: State) => IUserListSummary;
export declare const getSummaryActive: (state: State) => boolean;
export declare const getAnalyticFilteredMarkers: MemoizedSelector<State, any>;
export declare const getIndexFilteredMarkers: MemoizedSelector<State, any>;
export declare const getIndexActive: MemoizedSelector<State, boolean>;
export declare const getAnalyticsActive: MemoizedSelector<State, boolean>;
export declare const getIndexMarkersActive: MemoizedSelector<State, boolean>;
export declare const getAnalyticsMarkersActive: MemoizedSelector<State, boolean>;
