import { ActionReducer, ActionReducerFactory, ActionReducerMap, StoreFeature } from "./models";
import { BehaviorSubject } from "rxjs/BehaviorSubject";
import { Observable } from "rxjs/Observable";
import { Dispatcher } from "./dispatcher";
export declare abstract class ReducerObservable extends Observable<ActionReducer<any, any>> {
}
export declare abstract class ReducerManagerDispatcher extends Dispatcher {
}
export declare const UPDATE: "@ngrx/store/update-reducers";
export declare class ReducerManager extends BehaviorSubject<ActionReducer<any, any>> {
    private dispatcher;
    private initialState;
    private reducers;
    private reducerFactory;
    constructor(dispatcher: ReducerManagerDispatcher, initialState: any, reducers: ActionReducerMap<any, any>, reducerFactory: ActionReducerFactory<any, any>);
    addFeature({reducers, reducerFactory, metaReducers, initialState, key}: StoreFeature<any, any>): void;
    removeFeature({key}: StoreFeature<any, any>): void;
    addReducer(key: string, reducer: ActionReducer<any, any>): void;
    removeReducer(key: string): void;
    private updateReducers();
    ngOnDestroy(): void;
}
